<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "cpn_installation_provider".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "CpnInstallationProvider".
 *
 * Columns in table "cpn_installation_provider" available as properties of the model,
 * followed by relations of table "cpn_installation_provider" available as properties of the model.
 *
 * @property integer $id
 * @property integer $cpn_installation_id
 * @property integer $cpn_installation_user_id
 * @property integer $provider_id
 * @property string $fb_page_id
 * @property integer $scheduling_mail_notification
 * @property integer $twilio_log_notification
 * @property integer $provider_rating_notification
 * @property string $date_added
 * @property integer $added_by_account_id
 * @property string $date_updated
 * @property integer $updated_by_account_id
 *
 * @property CpnInstallationUser $cpnInstallationUser
 * @property Account $addedByAccount
 * @property CpnInstallation $cpnInstallation
 */
abstract class BaseCpnInstallationProvider extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'cpn_installation_provider';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'CpnInstallationProvider|CpnInstallationProviders', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('cpn_installation_id, added_by_account_id', 'required'),
            array('cpn_installation_id, cpn_installation_user_id, provider_id, scheduling_mail_notification, twilio_log_notification, provider_rating_notification, added_by_account_id, updated_by_account_id', 'numerical', 'integerOnly' => true),
            array('fb_page_id', 'length', 'max' => 25),
            array('date_added, date_updated', 'safe'),
            array('provider_id, fb_page_id, scheduling_mail_notification, twilio_log_notification, provider_rating_notification, date_added, date_updated, updated_by_account_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, cpn_installation_id, cpn_installation_user_id, provider_id, fb_page_id, scheduling_mail_notification, twilio_log_notification, provider_rating_notification, date_added, added_by_account_id, date_updated, updated_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'cpnInstallationUser' => array(self::BELONGS_TO, 'CpnInstallationUser', 'cpn_installation_user_id'),
            'addedByAccount' => array(self::BELONGS_TO, 'Account', 'added_by_account_id'),
            'cpnInstallation' => array(self::BELONGS_TO, 'CpnInstallation', 'cpn_installation_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'cpn_installation_id' => null,
            'cpn_installation_user_id' => null,
            'provider_id' => Yii::t('app', 'Provider'),
            'fb_page_id' => Yii::t('app', 'Fb Page'),
            'scheduling_mail_notification' => Yii::t('app', 'Scheduling Mail Enabled'),
            'twilio_log_notification' => Yii::t('app', 'Twilio Log Enabled'),
            'provider_rating_notification' => Yii::t('app', 'Provider Rating Enabled'),
            'date_added' => Yii::t('app', 'Date Added'),
            'added_by_account_id' => null,
            'date_updated' => Yii::t('app', 'Date Updated'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'cpnInstallationUser' => null,
            'addedByAccount' => null,
            'cpnInstallation' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('cpn_installation_id', $this->cpn_installation_id);
        $criteria->compare('cpn_installation_user_id', $this->cpn_installation_user_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('fb_page_id', $this->fb_page_id, true);
        $criteria->compare('scheduling_mail_notification', $this->scheduling_mail_notification);
        $criteria->compare('twilio_log_notification', $this->twilio_log_notification);
        $criteria->compare('provider_rating_notification', $this->provider_rating_notification);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
